#Variable aleatòria Exponencial
#l'Exponencial és un cas particular de la distribució Gamma
#on el valor del parmetre Alfa és = a 1

#Fixem la llavor per a que l'experiment sempre surti el mateix

set.seed(1000)

nobs<-500

#Creem els vectors necessaris del primer estimador
e_theta1.hat<-vector()
b_theta1.hat<-vector()
v_theta1.hat<-vector()
eqm_theta1.hat<-vector()
e2_theta1.hat<-vector()
b2_theta1.hat<-vector()
v2_theta1.hat<-vector()
eqm2_theta1.hat<-vector()

#Creem els vectors necessaris del segon estimador
e_theta2.hat<-vector()
b_theta2.hat<-vector()
v_theta2.hat<-vector()
eqm_theta2.hat<-vector()
e2_theta2.hat<-vector()
b2_theta2.hat<-vector()
v2_theta2.hat<-vector()
eqm2_theta2.hat<-vector()

#Fem simulaci per posibles parmetres theta per al primer estimador

theta <- seq(1,4,0.01)

for (i in seq(along=theta)){
	x1<-rexp(nobs,theta[i])
	x2<-rexp(nobs,theta[i])
#Primer estadstic
	theta1.hat<-(2*x1+4*x2)/3
	e_theta1.hat[i]<-mean(theta1.hat)
	v_theta1.hat[i]<-var(theta1.hat)
	b_theta1.hat[i]<-mean(theta1.hat)-theta[i]
	eqm_theta1.hat[i]<-b_theta1.hat[i]^2+v_theta1.hat[i]
	e2_theta1.hat<-rbind(e2_theta1.hat,e_theta1.hat[i])
	b2_theta1.hat<-rbind(b2_theta1.hat,b_theta1.hat[i])
	v2_theta1.hat<-rbind(v2_theta1.hat,v_theta1.hat[i])
	eqm2_theta1.hat<-rbind(eqm2_theta1.hat,eqm_theta1.hat[i])
#Segon estadstic
	theta2.hat<-(4*x1+5*x2)/3
	e_theta2.hat[i]<-mean(theta2.hat)
	v_theta2.hat[i]<-var(theta2.hat)
	b_theta2.hat[i]<-mean(theta2.hat)-theta[i]
	eqm_theta2.hat[i]<-b_theta2.hat[i]^2+v_theta2.hat[i]
	e2_theta2.hat<-rbind(e2_theta2.hat,e_theta2.hat[i])
	b2_theta2.hat<-rbind(b2_theta2.hat,b_theta2.hat[i])
	v2_theta2.hat<-rbind(v2_theta2.hat,v_theta2.hat[i])
	eqm2_theta2.hat<-rbind(eqm2_theta2.hat,eqm_theta2.hat[i])
}

#Matriu de resultats
res1<-cbind(theta,e2_theta1.hat,b2_theta1.hat,v2_theta1.hat,eqm2_theta1.hat)
nomscol<-c("theta","Esperana", "Biaix", "Varincia", "EQM")
colnames(res1)<-nomscol
res2<-cbind(theta,e2_theta2.hat,b2_theta2.hat,v2_theta2.hat,eqm2_theta2.hat)
colnames(res1)<-nomscol
colnames(res2)<-nomscol

res1; res2;
#Grfic
par(mfrow=c(3,1))
t1<-expression(italic(theta[1]))
t2<-expression(italic(theta[2]))
y<-seq(0,12,along=theta)
x<-theta
plot(x,y, xlab = expression(italic(theta)), ylab = "", main='Error Quadrtic Mitj', type="n")
lines(x,eqm2_theta1.hat, lty=1, lwd=3, col='blue')
lines(x,eqm2_theta2.hat, lty=1, lwd=3, col='red')
legend("topleft", c(t1,t2), lty=1, col=c("blue","red"), lwd=3, bty="n")

t1<-expression(italic(theta[1]))
t2<-expression(italic(theta[2]))
y<-seq(0,12,along=theta)
x<-theta
plot(x,y, xlab = expression(italic(theta)), ylab = "", main='Biaix al Quadrat',type="n")
lines(x,b2_theta1.hat^2, lty=1, lwd=3, col='blue')
lines(x,b2_theta2.hat^2, lty=1, lwd=3, col='red')
legend("topleft", c(t1,t2), lty=1, col=c("blue","red"), lwd=3, bty="n")

t1<-expression(italic(theta[1]))
t2<-expression(italic(theta[2]))
y<-seq(0,5,along=theta)
x<-theta
plot(x,y, xlab = expression(italic(theta)), ylab = "", main='Vairncia', type="n")
lines(x,v2_theta1.hat, lty=1, lwd=3, col='blue')
lines(x,v2_theta2.hat, lty=1, lwd=3, col='red')
legend("topright", c(t1,t2), lty=1, col=c("blue","red"), lwd=3, bty="n")

